#pragma once
#include "ScriptletContainerFactory.h"
#include "ValueConverter.h"
#include "Application.h"
#include "TipDocument.h"

namespace tipcommon
{
	class Representer4HotIcon : public IValueConverter
	{
	public:
		DECLARE_CONVERTER_CREATOR(Representer4HotIcon);
		Representer4HotIcon() {}
		~Representer4HotIcon() {}
		//override
		CComVariant Convert(CComVariant* src)
		{
			return CComVariant(src->intVal==2 ? SCRIPTLET_TRUE_VALUE : SCRIPTLET_FALSE_VALUE);
		}
	};

	class Representer4HighLevel : public IValueConverter
	{
	public:
		DECLARE_CONVERTER_CREATOR(Representer4HighLevel);
		Representer4HighLevel() {}
		~Representer4HighLevel() {}
		//override
		CComVariant Convert(CComVariant* src)
		{
			return CComVariant(src->intVal >= 1 ? TRUE : FALSE);
		}
	};

	class Representer4NotInstalled : public IValueConverter
	{
	public:
		DECLARE_CONVERTER_CREATOR(Representer4NotInstalled);
		Representer4NotInstalled() {}
		~Representer4NotInstalled() {}
		//override
		CComVariant Convert(CComVariant* src)
		{
			return CComVariant(src->intVal==InstallInfo::NOTINSTALLED ? SCRIPTLET_TRUE_VALUE : SCRIPTLET_FALSE_VALUE);
		}
	};
	class Representer4OldVersion : public IValueConverter
	{
	public:
		DECLARE_CONVERTER_CREATOR(Representer4OldVersion);
		Representer4OldVersion() {}
		~Representer4OldVersion() {}
		//override
		CComVariant Convert(CComVariant* src)
		{
			return CComVariant(src->intVal==InstallInfo::OLDVERSION ? SCRIPTLET_TRUE_VALUE : SCRIPTLET_FALSE_VALUE);
		}
	};
	class Representer4LastVersion : public IValueConverter
	{
	public:
		DECLARE_CONVERTER_CREATOR(Representer4LastVersion);
		Representer4LastVersion() {}
		~Representer4LastVersion() {}
		//override
		CComVariant Convert(CComVariant* src)
		{
			return CComVariant(src->intVal==InstallInfo::RECENTVERSION ? SCRIPTLET_TRUE_VALUE : SCRIPTLET_FALSE_VALUE);
		}
	};

	class Representer4Installed : public IValueConverter
	{
	public:
		DECLARE_CONVERTER_CREATOR(Representer4Installed);
		Representer4Installed() {}
		~Representer4Installed() {}
		//override
		CComVariant Convert(CComVariant* src)
		{
			return CComVariant(src->intVal==InstallInfo::NOTINSTALLED ? SCRIPTLET_FALSE_VALUE : SCRIPTLET_TRUE_VALUE );
		}
	};


};
